diff -r f3e24bd4d57e trytond/modules/sale/sale.py
--- a/trytond/modules/sale/sale.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -671,146 +573,143 @@
         default['invoices_ignored'] = None
         default['shipment_state'] = 'none'
         default.setdefault('sale_date', None)
-        return super(Sale, self).copy(ids, default=default)
+        return super(Sale, cls).copy(sales, default=default)
 
-    def check_for_quotation(self, ids):
-        sales = self.browse(ids)
-        for sale in sales:
-            if not sale.invoice_address or not sale.shipment_address:
-                self.raise_user_error('addresses_required')
-            for line in sale.lines:
-                if line.quantity >= 0:
-                    location = line.from_location
-                else:
-                    location = line.to_location
-                if ((not location or not line.warehouse)
-                        and line.product
-                        and line.product.type in ('goods', 'assets')):
-                    self.raise_user_error('warehouse_required')
+    def check_for_quotation(self):
+        if not self.invoice_address or not self.shipment_address:
+            self.raise_user_error('addresses_required')
+        for line in self.lines:
+            if line.quantity >= 0:
+                location = line.from_location
+            else:
+                location = line.to_location
+            if ((not location or not line.warehouse)
+                    and line.product
+                    and line.product.type in ('goods', 'assets')):
+                self.raise_user_error('warehouse_required')
 
-    def set_reference(self, ids):
+    @classmethod
+    def set_reference(cls, sales):
         '''
         Fill the reference field with the sale sequence
         '''
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('sale.configuration')
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('sale.configuration')
 
-        config = config_obj.browse(1)
-        sales = self.browse(ids)
+        config = Config(1)
         for sale in sales:
             if sale.reference:
                 continue
-            reference = sequence_obj.get_id(config.sale_sequence.id)
-            self.write(sale.id, {
-                'reference': reference,
-                })
+            reference = Sequence.get_id(config.sale_sequence.id)
+            cls.write([sale], {
+                    'reference': reference,
+                    })
 
-    def set_sale_date(self, ids):
-        date_obj = Pool().get('ir.date')
-        for sale in self.browse(ids):
+    @classmethod
+    def set_sale_date(cls, sales):
+        Date = Pool().get('ir.date')
+        for sale in sales:
             if not sale.sale_date:
-                self.write(sale.id, {
-                        'sale_date': date_obj.today(),
+                cls.write([sale], {
+                        'sale_date': Date.today(),
                         })
 
-    def store_cache(self, ids):
-        for sale in self.browse(ids):
-            self.write(sale.id, {
+    @classmethod
+    def store_cache(cls, sales):
+        for sale in sales:
+            cls.write([sale], {
                     'untaxed_amount_cache': sale.untaxed_amount,
                     'tax_amount_cache': sale.tax_amount,
                     'total_amount_cache': sale.total_amount,
                     })
 
-    def _get_invoice_line_sale_line(self, sale, invoice_type):
+    def _get_invoice_line_sale_line(self, invoice_type):
         '''
-        Return invoice line values for each sale lines according to
-        invoice_type
+        Return invoice line for each sale lines according to invoice_type
         '''
-        line_obj = Pool().get('sale.line')
         res = {}
-        for line in sale.lines:
-            val = line_obj.get_invoice_line(line, invoice_type)
+        for line in self.lines:
+            val = line.get_invoice_line(invoice_type)
             if val:
                 res[line.id] = val
         return res
 
-    def _get_invoice_sale(self, sale, invoice_type):
+    def _get_invoice_sale(self, invoice_type):
         '''
-        Return invoice values of type invoice_type for sale
-        '''
-        journal_obj = Pool().get('account.journal')
-
-        journal_id = journal_obj.search([
-            ('type', '=', 'revenue'),
-            ], limit=1)
-        if journal_id:
-            journal_id = journal_id[0]
-
-        res = {
-            'company': sale.company.id,
-            'type': invoice_type,
-            'reference': sale.reference,
-            'journal': journal_id,
-            'party': sale.party.id,
-            'invoice_address': sale.invoice_address.id,
-            'currency': sale.currency.id,
-            'account': sale.party.account_receivable.id,
-            'payment_term': sale.payment_term.id,
-            }
-        return res
-
-    def create_invoice(self, sale, invoice_type):
-        '''
-        Create an invoice of type invoice_type for the sale and return the id
+        Return invoice of type invoice_type
         '''
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        invoice_line_obj = pool.get('account.invoice.line')
-        sale_line_obj = pool.get('sale.line')
+        Invoice = pool.get('account.invoice')
+        Journal = pool.get('account.journal')
 
-        if sale.invoice_method == 'manual':
+        journals = Journal.search([
+                ('type', '=', 'revenue'),
+                ], limit=1)
+        if journals:
+            journal, = journals
+        else:
+            journal = None
+
+        with Transaction().set_user(0, set_context=True):
+            return Invoice(
+                company=self.company,
+                type=invoice_type,
+                reference=self.reference,
+                journal=journal,
+                party=self.party,
+                invoice_address=self.invoice_address,
+                currency=self.currency,
+                account=self.party.account_receivable,
+                payment_term=self.payment_term,
+                )
+
+    def create_invoice(self, invoice_type):
+        '''
+        Create and return an invoice of type invoice_type
+        '''
+        pool = Pool()
+        Invoice = pool.get('account.invoice')
+        SaleLine = pool.get('sale.line')
+        if self.invoice_method == 'manual':
             return
 
-        if not sale.party.account_receivable:
+        if not self.party.account_receivable:
             self.raise_user_error('missing_account_receivable',
-                    error_args=(sale.party.rec_name,))
+                    error_args=(self.party.rec_name,))
 
-        invoice_lines = self._get_invoice_line_sale_line(sale, invoice_type)
+        invoice_lines = self._get_invoice_line_sale_line(invoice_type)
         if not invoice_lines:
             return
 
-        vals = self._get_invoice_sale(sale, invoice_type)
-        with Transaction().set_user(0, set_context=True):
-            invoice_id = invoice_obj.create(vals)
+        invoice = self._get_invoice_sale(invoice_type)
+        invoice.save()
 
-        for line in sale.lines:
+        for line in self.lines:
             if line.id not in invoice_lines:
                 continue
-            for vals in invoice_lines[line.id]:
-                vals['invoice'] = invoice_id
-                with Transaction().set_user(0, set_context=True):
-                    invoice_line_id = invoice_line_obj.create(vals)
-                sale_line_obj.write(line.id, {
-                    'invoice_lines': [('add', invoice_line_id)],
-                    })
+            for invoice_line in invoice_lines[line.id]:
+                invoice_line.invoice = invoice.id
+                invoice_line.save()
+                SaleLine.write([line], {
+                        'invoice_lines': [('add', [invoice_line.id])],
+                        })
 
         with Transaction().set_user(0, set_context=True):
-            invoice_obj.update_taxes([invoice_id])
+            Invoice.update_taxes([invoice])
 
-        self.write(sale.id, {
-            'invoices': [('add', invoice_id)],
-        })
-        return invoice_id
+        self.write([self], {
+                'invoices': [('add', [invoice.id])],
+                })
+        return invoice
 
-    def _get_move_sale_line(self, sale, shipment_type):
+    def _get_move_sale_line(self, shipment_type):
         '''
-        Return a dictionary of move values for each sale lines of the right
-        shipment_type
+        Return move for each sale lines of the right shipment_type
         '''
-        line_obj = Pool().get('sale.line')
         res = {}
-        for line in sale.lines:
-            val = line_obj.get_move(line, shipment_type)
+        for line in self.lines:
+            val = line.get_move(shipment_type)
             if val:
                 res[line.id] = val
         return res
@@ -819,16 +718,13 @@
         '''
         The key to group moves by shipments
 
-        :param moves: a list of moves values
-        :param move: a tuple of line id and a dictionary of the move values
+        move is a tuple of line id and a move
+        '''
+        SaleLine = Pool().get('sale.line')
+        line_id, move = move
+        line = SaleLine(line_id)
 
-        :return: a list of key-value as tuples of the shipment
-        '''
-        sale_line_obj = Pool().get('sale.line')
-        line_id, move = move
-        line = sale_line_obj.browse(line_id)
-
-        planned_date = max(m['planned_date'] for m in moves)
+        planned_date = max(m.planned_date for m in moves)
         return (
             ('planned_date', planned_date),
             ('warehouse', line.warehouse.id),
@@ -836,168 +732,161 @@
 
     _group_return_key = _group_shipment_key
 
-    def create_shipment(self, sale, shipment_type):
+    def create_shipment(self, shipment_type):
         '''
-        Create a shipment of type shipment_type for the sale
-        and return the list of created shipment ids
+        Create and return shipments of type shipment_type
         '''
         pool = Pool()
-        move_obj = pool.get('stock.move')
-        sale_line_obj = pool.get('sale.line')
+        SaleLine = pool.get('sale.line')
 
-        if sale.shipment_method == 'manual':
+        if self.shipment_method == 'manual':
             return
 
-        moves = self._get_move_sale_line(sale, shipment_type)
+        moves = self._get_move_sale_line(shipment_type)
         if not moves:
             return
         if shipment_type == 'out':
             keyfunc = partial(self._group_shipment_key, moves.values())
             move_shipment_key = 'shipment_out'
-            shipment_obj = pool.get('stock.shipment.out')
+            Shipment = pool.get('stock.shipment.out')
         elif shipment_type == 'return':
             keyfunc = partial(self._group_return_key, moves.values())
             move_shipment_key = 'shipment_out_return'
-            shipment_obj = pool.get('stock.shipment.out.return')
+            Shipment = pool.get('stock.shipment.out.return')
         moves = moves.items()
         moves = sorted(moves, key=keyfunc)
 
         shipments = []
-        with Transaction().set_user(0, set_context=True):
-            for key, grouped_moves in groupby(moves, key=keyfunc):
-                values = {
-                    'customer': sale.party.id,
-                    'delivery_address': sale.shipment_address.id,
-                    'reference': sale.reference,
-                    'company': sale.company.id,
-                    }
-                values.update(dict(key))
-                shipment_id = shipment_obj.create(values)
-                shipments.append(shipment_id)
-                for line_id, values in grouped_moves:
-                    values[move_shipment_key] = shipment_id
-                    move_id = move_obj.create(values)
-                    sale_line_obj.write(line_id, {
-                        'moves': [('add', move_id)],
-                    })
-            if shipment_type == 'out':
-                shipment_obj.wait(shipments)
+        for key, grouped_moves in groupby(moves, key=keyfunc):
+            values = {
+                'customer': self.party.id,
+                'delivery_address': self.shipment_address.id,
+                'reference': self.reference,
+                'company': self.company.id,
+                }
+            values.update(dict(key))
+            with Transaction().set_user(0, set_context=True):
+                shipment = Shipment.create(values)
+                shipments.append(shipment)
+                for line_id, move in grouped_moves:
+                    setattr(move, move_shipment_key, shipment.id)
+                    move.save()
+                    SaleLine.write([SaleLine(line_id)], {
+                            'moves': [('add', [move.id])],
+                            })
+        if shipment_type == 'out':
+            with Transaction().set_user(0, set_context=True):
+                Shipment.wait(shipments)
         return shipments
 
-    def is_done(self, sale):
-        return ((sale.invoice_state == 'paid'
-                or sale.invoice_method == 'manual')
-            and (sale.shipment_state == 'sent'
-                or sale.shipment_method == 'manual'))
+    def is_done(self):
+        return ((self.invoice_state == 'paid'
+                or self.invoice_method == 'manual')
+            and (self.shipment_state == 'sent'
+                or self.shipment_method == 'manual'))
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, sales):
         # Cancel before delete
-        self.cancel(ids)
-        for sale in self.browse(ids):
+        cls.cancel(sales)
+        for sale in sales:
             if sale.state != 'cancel':
-                self.raise_user_error('delete_cancel', sale.rec_name)
-        return super(Sale, self).delete(ids)
+                cls.raise_user_error('delete_cancel', sale.rec_name)
+        super(Sale, cls).delete(sales)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        self.store_cache(ids)
+    def cancel(cls, sales):
+        cls.store_cache(sales)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
+    def draft(cls, sales):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('quotation')
-    def quote(self, ids):
-        self.check_for_quotation(ids)
-        self.set_reference(ids)
+    def quote(cls, sales):
+        for sale in sales:
+            sale.check_for_quotation()
+        cls.set_reference(sales)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('confirmed')
-    def confirm(self, ids):
-        self.set_sale_date(ids)
-        self.store_cache(ids)
+    def confirm(cls, sales):
+        cls.set_sale_date(sales)
+        cls.store_cache(sales)
 
+    @classmethod
     @ModelView.button_action('sale.wizard_invoice_handle_exception')
-    def handle_invoice_exception(self, ids):
+    def handle_invoice_exception(cls, sales):
         pass
 
+    @classmethod
     @ModelView.button_action('sale.wizard_shipment_handle_exception')
-    def handle_shipment_exception(self, ids):
+    def handle_shipment_exception(cls, sales):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('processing')
-    def process(self, ids):
+    def process(cls, sales):
         done = []
-        for sale in self.browse(ids):
+        for sale in sales:
             if sale.state in ('done', 'cancel'):
                 continue
-            self.create_invoice(sale, 'out_invoice')
-            self.create_invoice(sale, 'out_credit_note')
-            self.set_invoice_state(sale)
-            self.create_shipment(sale, 'out')
-            self.create_shipment(sale, 'return')
-            self.set_shipment_state(sale)
-            if self.is_done(sale):
-                done.append(sale.id)
+            sale.create_invoice('out_invoice')
+            sale.create_invoice('out_credit_note')
+            sale.set_invoice_state()
+            sale.create_shipment('out')
+            sale.create_shipment('return')
+            sale.set_shipment_state()
+            if sale.is_done():
+                done.append(sale)
         if done:
-            self.write(done, {
+            cls.write(done, {
                     'state': 'done',
                     })
 
-Sale()
-
 
 class SaleInvoice(ModelSQL):
     'Sale - Invoice'
-    _name = 'sale.sale-account.invoice'
+    __name__ = 'sale.sale-account.invoice'
     _table = 'sale_invoices_rel'
-    _description = __doc__
     sale = fields.Many2One('sale.sale', 'Sale', ondelete='CASCADE',
         select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-SaleInvoice()
-
 
 class SaleIgnoredInvoice(ModelSQL):
     'Sale - Ignored Invoice'
-    _name = 'sale.sale-ignored-account.invoice'
+    __name__ = 'sale.sale-ignored-account.invoice'
     _table = 'sale_invoice_ignored_rel'
-    _description = __doc__
     sale = fields.Many2One('sale.sale', 'Sale', ondelete='CASCADE',
         select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-SaleIgnoredInvoice()
-
 
 class SaleRecreatedInvoice(ModelSQL):
     'Sale - Recreated Invoice'
-    _name = 'sale.sale-recreated-account.invoice'
+    __name__ = 'sale.sale-recreated-account.invoice'
     _table = 'sale_invoice_recreated_rel'
-    _description = __doc__
     sale = fields.Many2One('sale.sale', 'Sale', ondelete='CASCADE',
         select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-SaleRecreatedInvoice()
-
 
 class SaleLine(ModelSQL, ModelView):
     'Sale Line'
-    _name = 'sale.line'
+    __name__ = 'sale.line'
     _rec_name = 'description'
-    _description = __doc__
-
     sale = fields.Many2One('sale.sale', 'Sale', ondelete='CASCADE',
         select=True)
     sequence = fields.Integer('Sequence',
@@ -1034,7 +923,7 @@
             '_parent_sale.party'],
         depends=['product', 'type', 'product_uom_category'])
     unit_digits = fields.Function(fields.Integer('Unit Digits',
-        on_change_with=['unit']), 'get_unit_digits')
+        on_change_with=['unit']), 'on_change_with_unit_digits')
     product = fields.Many2One('product.product', 'Product',
         domain=[('salable', '=', True)],
         states={
@@ -1054,7 +943,7 @@
     product_uom_category = fields.Function(
         fields.Many2One('product.uom.category', 'Product Uom Category',
             on_change_with=['product']),
-        'get_product_uom_category')
+        'on_change_with_product_uom_category')
     unit_price = fields.Numeric('Unit Price', digits=(16, 4),
         states={
             'invisible': Eval('type') != 'line',
@@ -1097,12 +986,13 @@
                 'invisible': Eval('type') != 'line',
                 },
             depends=['type']),
-        'get_delivery_date')
+        'on_change_with_delivery_date')
 
-    def __init__(self):
-        super(SaleLine, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(SaleLine, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._error_messages.update({
             'customer_location_required': 'The customer location is required!',
             'missing_account_revenue': 'It misses '
                     'an "Account Revenue" on product "%s"!',
